/****************************************************************************
** Interface to the GUI.
**
** Created: Tue 04 May 12:09:08 2004
**      by: Varol Okan using kate editor
**
** This class will create a toolbar, which holds only one widget.
** The StructureWidget is displaying the current structure of the DVD.
**
****************************************************************************/

#ifndef STRUCTURETOOLBAR_H
#define STRUCTURETOOLBAR_H

#include <qtoolbar.h>
#include <qsize.h>

class QListView;

class StructureToolBar : public QToolBar
{
	Q_OBJECT

public:
	 StructureToolBar (const QString &, QMainWindow *, QWidget *, bool b=FALSE, const char *n=0, WFlags f=0);
	~StructureToolBar ();

	QListView *listView();

	virtual QSize sizeHint () const;

private:
	QListView *m_pListViewStructure;
};

#endif // STRUCTURETOOLBAR_H


